
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Housekeeping_tasksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const housekeeping_tasks = await db.housekeeping_tasks.create(
            {
                id: data.id || undefined,
        
        scheduled_for: data.scheduled_for
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        task_type: data.task_type
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await housekeeping_tasks.setHotel( data.hotel || null, {
            transaction,
        });
        
        await housekeeping_tasks.setRoom( data.room || null, {
            transaction,
        });
        
        await housekeeping_tasks.setAssigned_staff_profile( data.assigned_staff_profile || null, {
            transaction,
        });
        
        await housekeeping_tasks.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return housekeeping_tasks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const housekeeping_tasksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                scheduled_for: item.scheduled_for
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                task_type: item.task_type
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const housekeeping_tasks = await db.housekeeping_tasks.bulkCreate(housekeeping_tasksData, { transaction });

        // For each item created, replace relation files
        

        return housekeeping_tasks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const housekeeping_tasks = await db.housekeeping_tasks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.scheduled_for !== undefined) updatePayload.scheduled_for = data.scheduled_for;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.task_type !== undefined) updatePayload.task_type = data.task_type;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await housekeeping_tasks.update(updatePayload, {transaction});

        
        
        if (data.hotel !== undefined) {
            await housekeeping_tasks.setHotel(
              
              data.hotel,
              
              { transaction }
            );
        }
        
        if (data.room !== undefined) {
            await housekeeping_tasks.setRoom(
              
              data.room,
              
              { transaction }
            );
        }
        
        if (data.assigned_staff_profile !== undefined) {
            await housekeeping_tasks.setAssigned_staff_profile(
              
              data.assigned_staff_profile,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await housekeeping_tasks.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return housekeeping_tasks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const housekeeping_tasks = await db.housekeeping_tasks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of housekeeping_tasks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of housekeeping_tasks) {
                await record.destroy({transaction});
            }
        });


        return housekeeping_tasks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const housekeeping_tasks = await db.housekeeping_tasks.findByPk(id, options);

        await housekeeping_tasks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await housekeeping_tasks.destroy({
            transaction
        });

        return housekeeping_tasks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const housekeeping_tasks = await db.housekeeping_tasks.findOne(
            { where },
            { transaction },
        );

        if (!housekeeping_tasks) {
            return housekeeping_tasks;
        }

        const output = housekeeping_tasks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.hotel = await housekeeping_tasks.getHotel({
            transaction
        });
        
        
        output.room = await housekeeping_tasks.getRoom({
            transaction
        });
        
        
        output.assigned_staff_profile = await housekeeping_tasks.getAssigned_staff_profile({
            transaction
        });
        
        
        output.organizations = await housekeeping_tasks.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.hotels,
        as: 'hotel',
        
        where: filter.hotel ? {
          [Op.or]: [
            { id: { [Op.in]: filter.hotel.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.hotel.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.rooms,
        as: 'room',
        
        where: filter.room ? {
          [Op.or]: [
            { id: { [Op.in]: filter.room.split('|').map(term => Utils.uuid(term)) } },
            {
              room_number: {
                [Op.or]: filter.room.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.staff_profiles,
        as: 'assigned_staff_profile',
        
        where: filter.assigned_staff_profile ? {
          [Op.or]: [
            { id: { [Op.in]: filter.assigned_staff_profile.split('|').map(term => Utils.uuid(term)) } },
            {
              employee_code: {
                [Op.or]: filter.assigned_staff_profile.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'housekeeping_tasks',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.scheduled_forRange) {
                const [start, end] = filter.scheduled_forRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    scheduled_for: {
                    ...where.scheduled_for,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    scheduled_for: {
                    ...where.scheduled_for,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.task_type) {
                where = {
                    ...where,
                task_type: filter.task_type,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.housekeeping_tasks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'housekeeping_tasks',
                        'task_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.housekeeping_tasks.findAll({
            attributes: [ 'id', 'task_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['task_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.task_type,
        }));
    }

    
};

